import socket
import math
from practicum import findDevices
from peri import PeriBoard
from time import sleep
from random import randrange


def startGame(HOST='127.0.0.1',PORT=8081):
    devs = findDevices()
    
    # if len dev == 2
    if len(devs) == 0:
        print "*** No MCU board found."
        exit(1)
    
    b = PeriBoard(devs[0])
    print "*** MCU board found"
    print "*** Device manufacturer: %s" % b.getVendorName()
    print "*** Device name: %s" % b.getDeviceName()
    
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    s.connect((HOST, PORT))
    round = 0
    oldLight = False
    newLight = False
    oldSwitch = False
    newSwitch = False
    checkVal = randrange(1000)
    # Run after server start
    s.sendall('JoinGame|' + str(b.getDeviceName())[3:] + '|' + str(checkVal) + '|' + b.getVendorName())
    
    setting = 15
    max = -1
    min = 1023
    while setting > 0 :
        try :
            sleep(0.02)
            lightVal = b.getLight()
            if lightVal > max :
                print 'please prepare max min LDR ---> max = ' + str(max) + ' min = ' + str(min)
                max = lightVal
            if lightVal < min :
                print 'please prepare max min LDR ---> max = ' + str(max) + ' min = ' + str(min)
                min = lightVal
            if b.getSwitch() :
                setting -= 1
        except:
            print 'bomb'
    print 'start shooting value to server.......'
    print '================================================================================='
    while True :
        sleep(0.02)
        try :
            newLight = b.getLight() < (min+max)/2
            if newLight != oldLight :
                s.sendall('TurnShipToggle|' + str(b.getDeviceName())[3:] + '|' + str(checkVal) + '|' + (b.getVendorName()))
    
            newSwitch = b.getSwitch()
            if newSwitch != oldSwitch :
                if newSwitch :
                    s.sendall('ShootingToggle|' + str(b.getDeviceName())[3:] + '|' + str(checkVal) + '|' + str(b.getVendorName()))
            oldSwitch = newSwitch
            print "ShootingServerRound %d ----> Switch state: %-8s | Light value: %d" % (round, b.getSwitch(), b.getLight())
            round += 1
        except :
            print 'bomb'
    data = s.recv(1024)
    s.close()
    print 'Received', repr(data)