var socket = io.connect('http://158.108.142.173:8080');

var GameLayer = cc.LayerColor.extend({
    init: function() {
        this.showText = 'Waiting For Host';
        this._super(new cc.Color4B(127, 127, 127, 255));
        this.textField = cc.LabelTTF.create(this.showText, GameLayer.FONT,30 );

        this.textNamePlayers = [];

        this.setPosition(new cc.Point(0, 0));
        this.IOSocket();
        this.setTextRemaining();
        this.ships = [];
        this.bullets = [];
        return true;
    },

    removeArrayAtIndex : function (arr, index) {
        return arr.splice(index, 1)[0];
    },

    updateTimer : function(timeRemaining) {
        if(timeRemaining > 0)
            this.showText = 'RemainingTime : ' + timeRemaining;
        else 
            this.showText = '========= GAME OVER =========';
        this.setTextRemaining();
    },

    createPlayers : function (players, index) {
        this.clearPlayers();
        for (var i = 0; i < players.length; i++) {
            this.ships[i] = new Ship(players[index[i]].lifepoint);
            this.updatePlayers(players, index, i);
            this.addChild(this.ships[i]);
        }    
    },

    updatePlayers : function (players, index, i) {
        this.ships[i].sid = players[index[i]].sid;
        this.ships[i].lifepoint = players[index[i]].lifepoint;
        this.ships[i].updatePositionRotation(players[index[i]].x, players[index[i]].y, players[index[i]].angle);

        this.textNamePlayers[i] = cc.LabelTTF.create(players[index[i]].sid, GameLayer.FONT, 20);
        this.textNamePlayers[i].setPosition(cc.p(players[index[i]].x + 32, players[index[i]].y - 15));
        this.addChild(this.textNamePlayers[i]);
    },

    updatePlayersPlaying : function (players, index) {
        for (var i = 0; i < players.length; i++) {
            if (this.ships[i].sid != players[index[i]].sid) {
                this.ships[i].lifepoint = players[index[i]].lifepoint;
                this.removeChild(this.ship[i]);
                this.ship[i].ctor(this.ships[i].lifepoint);
                this.addChild(this.ship[i]);
            }
            if (this.ship[i].lifepoint == 0) {
                this.removeChild(this.ship[i]);
            }
            else {
                this.ships[i].updatePositionRotation(players[index[i]].x, players[index[i]].y, players[index[i]].angle);
                this.textNamePlayers[i] = cc.LabelTTF.create(players[index[i]].sid, GameLayer.FONT, 20);
                this.textNamePlayers[i].setPosition(cc.p(players[index[i]].x + 32, players[index[i]].y - 15));
            }

        };
    },

    updateBullets : function (dataBullets) {
        while (this.bullets.length > 0) {
            this.removeChild(this.removeArrayAtIndex(this.bullets, 0));
        }
        for (var i = 0; i < dataBullets.length; i++) {
            this.bullets[i] = new Bullet();
            this.bullets[i].updatePositionXY(dataBullets[i].x, dataBullets[i].y);
            this.addChild(this.bullets[i]);
        }   
    },

    removeBullets : function (bulletsRemover) {
        for (var i = 0; i < bulletsRemover.length; i++) {
            indexBullet = bulletsRemover[i];
            this.removeChild(removeArrayAtIndex(this.bullets, indexBullet - i));
        };
    },

    clearPlayers : function () {
        while (this.ships.length > 0) {
            this.removeChild(this.removeArrayAtIndex(this.ships, 0));
            this.removeChild(this.removeArrayAtIndex(this.textNamePlayers, 0));

        }
    },

    IOSocket: function () {
        var self = this; // important

        socket.on('updateTimer', function(timeRemaining) {
            self.updateTimer(timeRemaining);
        });

        socket.on('createPlayers', function(players, index) {
            self.createPlayers(players, index);
        });

        socket.on('updatePlayers', function(players, index) {
            self.createPlayers(players, index);
            // self.updatePlayersPlaying(players, index);
        });

        socket.on('updateBullets', function(dataBullets) {
            self.updateBullets(dataBullets);
        });
    },

    setTextRemaining: function() {
        this.removeChild(this.textField);
        this.textField = cc.LabelTTF.create(this.showText, GameLayer.FONT,30 );
        this.textField.setPosition(cc.p(800/2, 600 - 25));
        this.addChild(this.textField);
    },
});

var StartScene = cc.Scene.extend({
    onEnter: function() {
        this._super();
        var layer = new GameLayer();
        layer.init();
        this.addChild( layer );
    }
});

socket.on('connect', function() {
    console.log('Connected');
});